﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module

Sub Class_Globals
	Private Act As Activity	
	Private Kyb As IME
	Private pnlTxt As Panel
	Private pnlClick As Panel
	Private  pnlErr As Panel
	Private edt As EditText
	Private mTarget As Object
	Private mEventName As String
	Private FldTyp As Byte 
	Private DecimalNo=0 As Byte 
	Private BorderWidth = 4 As Int
	Private ActiveBorderColor = Colors.RGB(255,128,0) As Int
	Private InActiveBorderColor = Colors.RGB(192,192,192) As Int
	Private PanelBkClr = Colors.White As Int
	Private ReadOnlyColor = Colors.RGB(255,255,204) As Int
	Private edtChangedState = True As Boolean
	Private ThousandSeparator As Boolean
	Private IsReadOnly = False As Boolean
	Private IsDoneBtn = False As Boolean
	Private CurrIcon = "" As String
	Private DD As DateDialog
	Private DtFormat = "dd/MM/yy" As String
	Private IsClickable = False As Boolean
	Private KybHandle As String
	Private IsPassMode = False As Boolean
	Private CC As ViewSetting
	Private R1,R2 As Float
	Private ValidListValue As List
	Private ValidStr As String

	Dim TypeText=1,TypeDate=2,TypeInt = 3,TypeFloat= 4,TypeCurrency=5 As Byte
	Dim TxtInpType As Int
	Dim InpTypCapWord = 8193 As Int
	Dim InpTypAllCap = 4097 As Int
	Dim InpTypFirstCap = 49153 As Int
	Dim InpTypNone = 1 As Int
	Dim HasError = False As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Target As Object, EventName As String )
	mTarget    = Target
	mEventName = EventName
	edt.Initialize("edt")
	edt.TextColor = Colors.Black
	CC.setCursorDrawableColor(edt,ActiveBorderColor)
	setFieldType(TypeText)
	Kyb.Initialize("Kyb")
	
End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, props As Map)
	Private CD As ColorDrawable
	CD.Initialize2(PanelBkClr,7,BorderWidth, InActiveBorderColor)	
	Base.AddView(edt, 0, 5, Base.Width, Base.Height+5dip)
	Base.Background = CD
	edt.Text 		= lbl.Text
	pnlTxt 	 		= Base
	Act 	 		= props.Get("activity")
	pnlErr.Initialize("")
End Sub

Public Sub setFieldType(Typ As Byte)
	FldTyp = Typ
	If(FldTyp = TypeText) Then
		edt.InputType = InpTypFirstCap
	Else If(FldTyp = TypeDate) Then
		setIcon("ic_menu_day")
		DateTime.DateFormat = DtFormat
		edt.Text = DateTime.Date(DateTime.Now)	
		setClickable(True)
	else If(FldTyp = TypeInt Or FldTyp = TypeFloat Or FldTyp = TypeCurrency) Then
		edt.Text = 0
		If(FldTyp = TypeCurrency) Then ThousandSeparator = True
		Kyb.SetCustomFilter(edt,edt.INPUT_TYPE_DECIMAL_NUMBERS,"0123456789-")
	End If
	FormatField(False)
End Sub

Public Sub setDigitsGroup(flag As Boolean)
	ThousandSeparator = flag
	FormatField(False)
End Sub

Public Sub setDecNo(No As Int)
	DecimalNo = No
	FormatField(False)
	If DecimalNo > 0 Then edt.InputType = edt.INPUT_TYPE_DECIMAL_NUMBERS
End Sub

Private Sub getInternalValue As String
	Try
		If(FldTyp = TypeInt Or FldTyp = TypeFloat Or FldTyp = TypeCurrency) Then 
			Return edt.Text.Replace(",", "")
		If edt.Text = "." Then Return "0"
		else If(FldTyp = TypeText Or FldTyp = TypeDate) Then 
			Return edt.Text.Replace("","")
		End If
	Catch
		Return "0"		
	End Try
End Sub

Private Sub FormatField(HasFocus As Boolean) As Boolean
	If IsPassMode Then Return
	Try
		edt.Text = getInternalValue
		If(FldTyp = TypeInt Or FldTyp = TypeFloat Or FldTyp = TypeCurrency) Then
			edt.Gravity = Gravity.RIGHT
			If IsReadOnly Then Return
		
			If (edt.Text = "") Then edt.Text = "0"
			
			If(DecimalNo > 0) Then
				Private Num As Double
				Num = edt.Text
				
				If HasFocus = False Then 
					edt.Text = NumberFormat2(Num,1,DecimalNo,DecimalNo,ThousandSeparator)
				End If
			Else
				Private NumInt As Int
				NumInt = edt.Text
				
				If HasFocus = False Then 
					edt.Text = NumberFormat2(NumInt,0,0,0,ThousandSeparator)
				End If
			End If
		Else If(FldTyp = TypeText) Then edt.Gravity = Gravity.LEFT
		Else if FldTyp = TypeDate Then DateTime.DateFormat = DtFormat
		End If	
		Return True
	Catch
		If(FldTyp = TypeInt Or FldTyp = TypeFloat Or FldTyp = TypeCurrency) Then 
			edt.Text = 0
		Else
			edt.Text = ""
		End If
		Return False
	End Try
End Sub

Public Sub getText As String
	Return getInternalValue
End Sub

Public Sub setText(Val As String)
	edt.Text = Val
	If(FldTyp = TypeInt Or FldTyp = TypeFloat Or FldTyp = TypeCurrency) Then FormatField(False)
End Sub

Public Sub setTextColor(Clr As Int)
	edt.TextColor = Clr
End Sub

Public Sub setReadOnly(flag As Boolean)
	IsReadOnly = flag
	Private CD As ColorDrawable
	If IsReadOnly Then
		CD.Initialize2(ReadOnlyColor,7,BorderWidth, InActiveBorderColor)	
		edt.SelectionStart = 0
	Else		
		CD.Initialize2(PanelBkClr,7,BorderWidth, InActiveBorderColor)
	End If
	pnlTxt.Background = CD
End Sub

Public Sub RequestFocus As Boolean
	edt.RequestFocus
End Sub

Public Sub setForceDoneButton(flag As Boolean)
	edt.ForceDoneButton = flag
	IsDoneBtn = flag
End Sub

Public Sub setIcon(IconName As String)
	Dim AR As AndroidResources
    Dim ETxt As JavaObject = edt
	ETxt.RunMethod("setCompoundDrawablesWithIntrinsicBounds",Array As Object(Null,Null,AR.GetAndroidDrawable( IconName),Null))
	CurrIcon = IconName
End Sub

Public Sub setClickable(flag As Boolean)
	IsClickable = flag
	
	If pnlClick.IsInitialized Then pnlClick.RemoveView
	
	If IsClickable Then
		pnlClick.Initialize("pnlClick")
		pnlClick.Color = Colors.Transparent
		pnlTxt.AddView(pnlClick,0,0,pnlTxt.Width, pnlTxt.Height)
		setReadOnly(True)
	End If
End Sub

Public Sub getView As EditText
	Return edt
End Sub

Public Sub setPasswordMode(flag As Boolean)
	edt.PasswordMode = flag
	IsPassMode = flag
End Sub

Public Sub setRequired(flag As Boolean)
	KybHandle = "Required"
	Kyb.AddHandleActionEvent(edt)
End Sub

Public Sub Range(Range1 As Float,Range2 As Float)
	If FldTyp <> TypeCurrency And FldTyp <> TypeFloat And FldTyp <> TypeInt Then Return
	R1 = Range1
	R2 = Range2
	KybHandle = "CheckRange"
	Kyb.AddHandleActionEvent(edt)
End Sub

Sub ParseStr(Str As String) 
	Private Pos As Int
	Pos = Str.IndexOf(",")  
	If Pos > 0 Then
		ValidListValue.Add(Str.SubString2(0,Pos))
		Str = Str.SubString2(Pos+1,Str.Length)
		ParseStr(Str)
	Else
		ValidListValue.Add(Str)
	End If
End Sub

Public Sub ValidValue(ValList As String)
	If FldTyp <> TypeText Then Return
	ValidStr = ValList
	If ValidListValue.IsInitialized = False Then ValidListValue.Initialize
	ParseStr(ValList)
	KybHandle = "CheckValidValue"
	Kyb.AddHandleActionEvent(edt)
End Sub

Private Sub Kyb_HandleAction As Boolean
   	If KybHandle = "Required" Then
		Private Str As String
		Str = getInternalValue
		
		If Str = "" Then
			HasError = True
    	  	ShowError("Field must have a value!")
      		Return True
		End If
	Else if KybHandle = "CheckRange" Then
		Private Fl As Float
		Fl = getInternalValue
		If Fl < R1 Or Fl > R2 Then
			HasError = True
	      	ShowError("Out of range! " & "Valid range : " & R1 & " - " & R2 )
    	  	Return True
		End If	
	Else if KybHandle = "CheckValidValue" Then
		Private Str As String
		Str = getInternalValue
		For i = 0 To ValidListValue.Size-1
			If Str = ValidListValue.Get(i) Then
		   		HideErr(True)
				HasError = False
   				Return False 				
			End If
		Next
		HasError = True
	    ShowError("Not Valid value! " & "Valid values are : " & ValidStr)
    	Return True
	End If
   	
	HideErr(True)
	HasError = False
   	Return False 
End Sub

Public Sub ShowError(ErrMsg As String)
	Private AR As AndroidResources
    Private ETxt As JavaObject = edt
	ETxt.RunMethod("setCompoundDrawablesWithIntrinsicBounds",Array As Object(Null,Null,AR.GetAndroidDrawable("indicator_input_error"),Null))

	Private ScrollVPos = 0 As Int
	
	For Each v As View In Act.GetAllViewsRecursive
		If v Is ScrollView Then
			Private S As ScrollView
			S = v
			ScrollVPos = S.ScrollPosition
		End If
	Next
	
	Private Lb As Label
	Lb.Initialize("")
	Lb.Text     = ErrMsg
	Lb.Gravity 	= Gravity.RIGHT
	
	Private Cnv As Canvas
	Private Width As Float
	Cnv.Initialize(pnlTxt)
	Width = Cnv.MeasureStringWidth( ErrMsg,Typeface.DEFAULT,12)	
	
	If pnlErr.IsInitialized Then pnlErr.RemoveView
	
	Act.AddView(pnlErr,0,pnlTxt.Top+pnlTxt.Height-ScrollVPos,Width*1.40,pnlTxt.Height-3dip)
	Scale.SetRight(pnlErr,Scale.Right(pnlTxt))
	pnlErr.SetBackgroundImage(LoadBitmap(File.DirAssets,"popup_inline_error.png"))
	pnlErr.AddView(Lb,0,15dip ,pnlErr.Width-15dip,pnlErr.Height)
	pnlErr.Visible = True
	HasError 	   = True	
End Sub

Public Sub HideErr(RestoreIcon As Boolean)
	pnlErr.Visible = False
	If RestoreIcon Then setIcon(CurrIcon)
End Sub

Private Sub edt_FocusChanged (HasFocus As Boolean)
	Private CD As ColorDrawable
	FormatField(HasFocus)
	If HasFocus Then 	
		If IsReadOnly Then
			Kyb.HideKeyboard
			CD.Initialize2(ReadOnlyColor,7,BorderWidth, InActiveBorderColor)	
		Else
			edt.SelectAll 		
			Kyb.ShowKeyboard(edt)
			CD.Initialize2(PanelBkClr,7,BorderWidth, ActiveBorderColor)
		End If
		If SubExists(mTarget,mEventName.Trim & "_GotFocus") Then CallSub(mTarget,mEventName.Trim & "_GotFocus")
	Else
		If IsReadOnly Then
			CD.Initialize2(Colors.RGB(255,255,204),7,BorderWidth, InActiveBorderColor)	
		Else
			CD.Initialize2(PanelBkClr,7,BorderWidth, InActiveBorderColor)
		End If
		If SubExists(mTarget,mEventName.Trim & "_LostFocus") Then CallSub(mTarget,mEventName.Trim & "_LostFocus")
	End If
	pnlTxt.Background = CD
End Sub

Private Sub edt_EnterPressed
	If IsDoneBtn Then		
		If SubExists(mTarget,mEventName.Trim & "_EnterPressed") Then CallSub(mTarget,mEventName.Trim & "_EnterPressed")
	Else
		If SubExists(mTarget,mEventName.Trim & "_NextPressed") Then CallSub(mTarget,mEventName.Trim & "_NextPressed")
	End If
End Sub

Private Sub edt_TextChanged (Old As String, New As String)
	If Old = New Then Return
	
	If edtChangedState = False Then 
		edtChangedState = True	
		Return
	End If
	
	If IsReadOnly Then 
		edtChangedState = False
		edt.Text = Old	
	Else
		If SubExists(mTarget,mEventName.Trim & "_TextChanged") Then CallSub3( mTarget,mEventName.Trim & "_TextChanged",Old,New)		
	End If
End Sub 

Private Sub pnlClick_Click
	edt.RequestFocus
	
	If(FldTyp = TypeDate) Then 
		DD.ShowCalendar = False
		DD.DateTicks = DateTime.Now
		If DD.Show("","Select Date","OK","Cancel","",LoadBitmap(File.DirAssets,"calendar.png")) = DialogResponse.POSITIVE Then
			setReadOnly(False) 
			edt.Text = DateTime.Date(DD.DateTicks)
			setReadOnly(True) 
		End If
		Return
	End If
	If SubExists(mTarget,mEventName.Trim & "_Clicked") Then CallSub(mTarget,mEventName.Trim & "_Clicked")
End Sub
